/**
  * Aller (le terrier d'AbulEdu)
  *
  * @warning aucun traitement d'erreur n'est pour l'instant implémenté
  * @see https://redmine.ryxeo.com/projects/leterrier-aller
  * @author 2011 Jean-Louis Frucot <frucot.jeanlouis@free.fr>
  * @see The GNU Public License (GPL)
  */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#include "abuledugraphicsteteswidgetv1.h"
#include <QDebug>
AbulEduGraphicsTetesWidgetV1::AbulEduGraphicsTetesWidgetV1(QString prefixeTete, int nbTete, int taille,QGraphicsWidget *parent ) :
    QGraphicsWidget(parent)
{

    Q_UNUSED(parent)
    m_taille =QSize(taille, taille);
    m_listeTetes.clear();
    suffixe = new QMap<int, QString>();
    suffixe->insert(0, "Neutre");
    suffixe->insert(1, "Bien");
    suffixe->insert(2, "Passable");
    suffixe->insert(3, "Mal");

    marge = 10;
    m_contour=QColor(Qt::black); // On peut passer un QPen plus complexe
    m_background = QColor(Qt::lightGray); //Pareil voir la doc sur les QPen et QBrush
    setAutoFillBackground(false);
    resetTetes(prefixeTete, nbTete, parent);

}
void AbulEduGraphicsTetesWidgetV1::resetTetes(QString prefixeTete, int nbTete, QGraphicsWidget *parent)

{
    // On efface toutes les têtes
    foreach(QGraphicsPixmapItem *tmpItem, listePixmapTetes)
    {
        delete tmpItem;
    }

    listePixmapTetes.clear();
    m_listeTetes.clear();
    m_prefixe = prefixeTete;
    int x=marge;
    int y = marge;
    for(int i=0; i<nbTete; i++)
    {
        QGraphicsPixmapItem *pixTete = new QGraphicsPixmapItem();
        pixTete->setParentItem(this);
        pixTete->setPixmap(QPixmap(QString(":/"+m_prefixe+"/Neutre")).scaled(m_taille,Qt::KeepAspectRatio, Qt::SmoothTransformation));
        pixTete->setPos(x, y);
        x=x+m_taille.width()+marge;

        listePixmapTetes.append(pixTete);
        m_listeTetes.append(0); // Tete Neutre

        setGeometry(pos().x(), pos().y(),(m_taille.width() + 10)*nbTete + marge, m_taille.height() + marge*2 );
    }

}

void AbulEduGraphicsTetesWidgetV1::setEtatTete(int numTete, int tete)
{
    if(numTete < listePixmapTetes.size() && tete>=0 && tete < 4)
    {
        QGraphicsPixmapItem *pixTete = listePixmapTetes[numTete];

        pixTete->setPixmap(QPixmap(QString(":/"+m_prefixe+"/"+suffixe->value(tete))).scaled(m_taille, Qt::KeepAspectRatio, Qt::SmoothTransformation));
        m_listeTetes[numTete]=tete;
    }
}

void AbulEduGraphicsTetesWidgetV1::resizeTetes(int taille)
{
    m_taille = QSize(taille, taille);
    int x = marge;
    int y = marge;
    for(int i = 0; i < listePixmapTetes.size(); i++)
    {
        listePixmapTetes[i]->setPos(x,y);
        x=x+m_taille.width()+marge;

        setEtatTete(i, m_listeTetes[i]); // Redessine la tête dans son état antérieur et à la nouvelle taille
    }
    setGeometry(pos().x(), pos().y(),(m_taille.width() + 10)*listePixmapTetes.size() + marge, m_taille.height() + marge*2 );
}

int AbulEduGraphicsTetesWidgetV1::getEtatTete(int numTete)
{
    return m_listeTetes[numTete];
}

QList<int> AbulEduGraphicsTetesWidgetV1::getEtatTetes()
{
    return m_listeTetes;
}

void AbulEduGraphicsTetesWidgetV1::setCouleurs(QPen contour, QBrush brosse)
{
    m_contour = contour;
    m_background = brosse;
}

void AbulEduGraphicsTetesWidgetV1::paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget)
{
    painter->setPen(m_contour);
    painter->setBrush(m_background);
    painter->drawRoundedRect(boundingRect(), marge, marge);
}

QRectF AbulEduGraphicsTetesWidgetV1::boundingRect()
{
    return QRectF(0,0,geometry().width(), geometry().height());
}
